Project Chrono: chrono::sensor::ChOptixSensor Class Reference

Public Member Functions | Protected Attributes | List of all members
chrono::sensor::ChOptixSensor Class Reference
SENSOR module » Sensors

## Description

Optix sensor class - the base class for all sensors that interface with OptiX to generate and render their data.

`#include <ChOptixSensor.h>`

Inheritance diagram for chrono::sensor::ChOptixSensor:
[legend]
Collaboration diagram for chrono::sensor::ChOptixSensor:
[legend]

## Public Member Functions
| ChOptixSensor (std::shared_ptr< chrono::ChBody > parent, float updateRate, chrono::ChFrame< double > offsetPose, unsigned int w, unsigned int h)
| Constructor for the base camera class that defaults to a pinhole lens model.
virtual | ~ChOptixSensor ()
| camera class destructor
PipelineType | GetPipelineType ()
unsigned int | GetWidth ()
unsigned int | GetHeight ()
CUstream | GetCudaStream ()
Public Member Functions inherited from chrono::sensor::ChSensor
| ChSensor (std::shared_ptr< chrono::ChBody > parent, float updateRate, chrono::ChFrame< double > offsetPose)
| Constructor for the base sensor class.
virtual | ~ChSensor ()
| Class destructor.
void | SetOffsetPose (chrono::ChFrame< double > pose)
| Set the sensor's relative position and orientation.
ChFrame< double > | GetOffsetPose ()
| Get the sensor's relative position and orientation.
std::shared_ptr< ChBody > | GetParent () const
| Get the object to which the sensor is attached.
void | SetName (std::string name)
| Set the sensor's name.
std::string | GetName () const
| Get the name of the sensor.
float | GetUpdateRate () const
| Get the sensor update rate (Hz).
void | SetLag (float t)
| Set the lag parameter.
float | GetLag () const
| Get the sensor lag (seconds).
void | SetCollectionWindow (float t)
| Set the collection window.
float | GetCollectionWindow () const
| Get the sensor data collection window (seconds).
void | SetUpdateRate (float updateRate)
| Set the sensor update rate (Hz).
unsigned int | GetNumLaunches ()
| Get the number of times the sensor has been updated.
void | IncrementNumLaunches ()
| Increments the count of number of updates.
std::list< std::shared_ptr< ChFilter > > | GetFilterList () const
| Get the sensor's list of filters.
void | PushFilter (std::shared_ptr< ChFilter > filter)
| Add a filter to the sensor.
void | PushFilterFront (std::shared_ptr< ChFilter > filter)
| Add a filter to the front of the list on a sensor.
void | LockFilterList ()
| Gives ability to lock the filter list to prevent race conditions.
template<class UserBufferType>
UserBufferType | GetMostRecentBuffer ()
| Get the last filter in the list that matches the template type.
template<>
CH_SENSOR_API UserR8BufferPtr | GetMostRecentBuffer ()
template<>
CH_SENSOR_API UserRGBA8BufferPtr | GetMostRecentBuffer ()
template<>
CH_SENSOR_API UserDepthBufferPtr | GetMostRecentBuffer ()
template<>
CH_SENSOR_API UserDIBufferPtr | GetMostRecentBuffer ()
template<>
CH_SENSOR_API UserXYZIBufferPtr | GetMostRecentBuffer ()
template<>
CH_SENSOR_API UserRadarBufferPtr | GetMostRecentBuffer ()
template<>
CH_SENSOR_API UserRadarXYZBufferPtr | GetMostRecentBuffer ()
template<>
CH_SENSOR_API UserAccelBufferPtr | GetMostRecentBuffer ()
template<>
CH_SENSOR_API UserGyroBufferPtr | GetMostRecentBuffer ()
template<>
CH_SENSOR_API UserMagnetBufferPtr | GetMostRecentBuffer ()
template<>
CH_SENSOR_API UserGPSBufferPtr | GetMostRecentBuffer ()
template<>
CH_SENSOR_API UserTachometerBufferPtr | GetMostRecentBuffer ()

## Protected Attributes
PipelineType | m_pipeline_type
| the type of pipeline for rendering
Protected Attributes inherited from chrono::sensor::ChSensor
float | m_updateRate
| sensor update rate
float | m_lag
| sensor lag from the time all scene information is available (sensor processing time)
float | m_collection_window
| time over which data is collected.
float | m_timeLastUpdated
| time since previous update
std::shared_ptr< chrono::ChBody > | m_parent
| object to which the sensor is attached
chrono::ChFrame< double > | m_offsetPose
| position and orientation of the sensor relative to its parent
std::string | m_name
| name of the sensor
unsigned int | m_num_launches
| number of times the sensor has been updated
std::list< std::shared_ptr< ChFilter > > | m_filters
| filter list for post-processing sensor data
bool | m_filter_list_locked = false
| gives ability to lock the filter list to prevent race conditions

## Constructor & Destructor Documentation

## ◆ ChOptixSensor()

CH_SENSOR_API chrono::sensor::ChOptixSensor::ChOptixSensor | ( | std::shared_ptr< chrono::ChBody > | parent,
|  | float | updateRate,
|  | chrono::ChFrame< double > | offsetPose,
|  | unsigned int | w,
|  | unsigned int | h )

Constructor for the base camera class that defaults to a pinhole lens model.

Parameters

  parent | Body to which the sensor is attached.
  updateRate | Rate at which the sensor should update.
  offsetPose | Relative position and orientation of the sensor with respect to its parent object.
  w | Width of the data the sensor should generate
  h | Height of the data the sensor should generate

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono_sensor/sensors/ChOptixSensor.h
- D:/W/B/src/chrono-9.0.1/src/chrono_sensor/sensors/ChOptixSensor.cpp